import os
import sys
from urllib.parse import urlparse, urljoin
#from rich import print
from patterns import FINAL_URL_PATTERNS
from pyparsing import ParseException



def extract_from_cdx(filename):
    f = open(filename, 'r', encoding='utf8')
    n = 0
    results = []
    for l in f:
        n += 1
        if n == 1: continue
        results.append(l.split(' ', 1)[0])
    return results


def urllist_analyzer(urllist):
     report = {'domains' : {}, 'total' : len(urllist)}
     for u in urllist:
         o = urlparse(u)
         if o.netloc not in report['domains']:
             report['domains'][o.netloc] = {'total' : 0, 'level1' : {}}
         report['domains'][o.netloc]['total'] += 1
         parts = o.path.split('/')
         if len(parts) > 1:
             level1 = parts[1]
             if level1 not in report['domains'][o.netloc]['level1'].keys():
                 report['domains'][o.netloc]['level1'][level1] = 0
             report['domains'][o.netloc]['level1'][level1] += 1
#         print(o)
     return report
     

def extract_url_scheme(urllist):
    """Extracts url schemes
    :param urllist:
    """
    global tn
    res = []
    properties = {'total': 0, 'hasquery': False, 'hasnonquery': False, 'mixed': False, 'onelevel': False, 'levels': {},
                  'params': {}}
    urltypes = {}
    params = {}
    exts = {}
    level = 1
#    gu = urlparse(url)
    #   print url
    n = 0
    for url in urllist:
        n += 1
        if n % 1000 == 0: print(n)
        if n % 5000 == 0: break
        theu = {'href' : url}
        u = urlparse(theu['href'])
        if u.scheme in ['ftp', 'mailto', 'javascript']:
            continue
        theu['path'] = u.path
        if u.query:
            properties['hasquery'] = True
            allp = u.query.split('&')
            key = len(allp)
            v = params.get(key, 0)
            params[key] = v + 1
            pdata = []
            for k in allp:
                urlp = k.split('=', 1)
                if urlp[0].upper() != 'PHPSESSIOND':
                    pdata.append(urlp)
            theu['params'] = pdata
            if not len(pdata):
                properties['hasquery'] = False
        else:
            if theu['path'] != '/':
                properties['hasnonquery'] = True
        parts = u.path.strip('/').split('/')
        theu['parts'] = parts
        theu['plen'] = len(parts)
        v = properties['levels'].get(len(parts), 0)
        properties['levels'][len(parts)] = v + 1
        extp = parts[-1].rsplit('.', 1)
        if len(extp) > 1 and len(extp[1]) < 6:
            ext = extp[1]
        else:
            ext = ''
        theu['ext'] = ext
        res.append(theu)
        v = exts.get(ext, 0)
        exts[ext] = v + 1
        properties['total'] += 1
    properties['exts'] = exts
    properties['params'] = params
    if len(properties['levels']) == 1:
        properties['onelevel'] = True
    if properties['hasquery'] and properties['hasnonquery']:
        properties['mixed'] = True
        #properties['onelevel'] and
    if not properties['hasquery'] and properties['hasnonquery'] and properties['exts'].has_key('htm') and properties['exts']['htm'] / float(properties['total']) > 0.5:
        pass
    if properties['hasnonquery']:
        if properties['hasquery']:
            key = 'mixed'
        #            print url
        #            for u in res:
        #                print '-', u['href']
        else:
            if properties['hasnonquery'] and properties['exts'].has_key('htm') and properties['exts']['htm'] / float(
                    properties['total']) > 0.5:
                key = "static"
            else:
                key = 'notquery'
    else:
        if properties['hasquery']:
            key = 'queried'
        else:
            key = 'unrecognized'
        #           print url
    uniqlist = []
    for l in properties['levels']:
        if l > 0:
            for u in res:
                found = False
                clean_path = urlparse(urljoin(url, u['path'])).path
                if clean_path in uniqlist:
                    continue
                else:
                    uniqlist.append(clean_path)
#                print(FINAL_URL_PATTERNS)
                for rkey, rpat in FINAL_URL_PATTERNS.items():
                    try:
                        r = rpat.parseString(clean_path)
                        print(rkey, clean_path)
#                        print url, rkey, u['path'].encode('utf8', 'ignore'), clean_path
                        found = True
                        break
                    except ParseException:
                        pass
                if not found:
                    print('- not matched:', clean_path)
                    pass
                else:
                    v = urltypes.get(rkey, 0)
                    urltypes[rkey] = v + 1
                    if rkey.find('yyyy]') > -1:
                        print('!! matched', clean_path, rkey)

##                    print u['path'].encode('utf8', 'ignore'), clean_path.encode('utf8', 'ignore')
            if found:
                continue
    properties['urltypes'] = urltypes
    print(url, properties)
    patterned = 0
    for k, v in urltypes.items():
        patterned += v
        print('-', k, v)
#    ptn = len(urltypes)
    pshare =  patterned * 100.0 / properties['total']  if properties['total'] else 0.0
    print('Patterned share', pshare)
    print('---')



def run(filename):
    results = extract_from_cdx(filename)
    extract_url_scheme(results)
    #report = urllist_analyzer(results)
    #print(report)


if __name__ == '__main__':
    run(sys.argv[1])